/*
 * Copyright (c) 2003 Communication Networks Lab, Simon Fraser University.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Authors: Steve Wei Shen <wshen@cs.sfu.ca>.
 *
 */ 

#include "vecroutes.h"

/** Add a route and update the route count */
void vecRoutes::add(Route* r) {
  if(routes.size() == 0) {
    routes.push_back(r);
    counts.push_back(1);
  }
  else {
   int j;
   int k = 0;
   for(j = 0; j<routes.size(); j++) {
     if(routes[j]->equals(r)) {
  	counts[j] = counts[j] + 1;
     	k = 1;
        break;
     }
   }
   if(k == 0) {
     routes.push_back(r);
     counts.push_back(1);
   }
  }
}

/** Clear all routes in the vector */
void vecRoutes::clear() {
  routes.clear();
  counts.clear();
}
    
/** Search for a route in the vector */
int vecRoutes::find(Route* r) {
  for(int i=0; i<routes.size(); i++) {
    if(routes[i]->equals(r)) {
      return counts[i];
    }
  }
  return 0;
}

