/*
 * Copyright (c) 2003 Communication Networks Lab, Simon Fraser University.
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Authors: Steve Wei Shen <wshen@cs.sfu.ca>,  Z. Morley Mao.
 *
 */


#ifndef DAMP_REUSE_TIMER_H
#define DAMP_REUSE_TIMER_H

#include "timer-handler.h"

class rtProtoBGP;
class DampInfo;

/** A timer for helping to determine when a damped route may be reused again. */
class DampReuseTimer : public TimerHandler  {
 
 public:
  DampReuseTimer(rtProtoBGP* b, double t, DampInfo* di);
  void expire(Event *e);
  void reset();
  bool scheduled();
  inline bool is_pending() { return status_ == TIMER_PENDING; }
  inline bool is_idle() { return  status_ == TIMER_IDLE;}
  double supTime;

 private:
  rtProtoBGP* bgp;
  DampInfo* dampInfo;
};

#endif



