
// BGP PROCESSING DELAY


#include "processing_delay.h"     
#include "../rtProtoBGP.h"


//RNG* CPUTimer::rng= new RNG( (long int) 56789);
//RNG* CPUTimer::rng= new RNG( (long int) 0);

// ----- constructor CPUTimer ------------------------------------ //
/**
 *
 */
   
CPUTimer::CPUTimer (rtProtoBGP *b) : TimerHandler()
{
  bgp = b ;
  round = 0.2 ; //default value is 0.2  For simulating higher traffic loads, use longer round durations
}         

// ----- destructor CPUTimer ------------------------------------ //

CPUTimer::~CPUTimer()
{
}


// ----- expire CPUTimer ------------------------------------ //

void CPUTimer::expire(Event *e)
{

      if (!bgp->alive) { return; } // die() could have been called while waiting

      for ( int i = 0 ; i < bgp -> inbuf . size ( ) ; i ++ )
      {
        
        //cputimer expired, so handle all the update in the inbuf
        bgp->handle_update ( bgp->inbuf[i] );
      }
      
      //after handlign we don't need them anymore, so delete them from the deque
      bgp->inbuf.clear();

      resched( round );
}

