/*

 *
 */ 

#ifndef REUSABLEMRAITIMER_H
#define REUSABLEMRAITIMER_H

#include "timer-handler.h"
#include "set" 
#include "iostream" 
#include "../route.h"
#include "../global.h"
#include "../Comm/updatemessage.h"
#include "../peer-entry.h" 

class rtProtoBGP;
class PeerEntry;
                                  
/**
 * Author: Nenad Laskovic <nlaskovi@cs.sfu.ca>
 */
class reusableMRAItimer : public TimerHandler
{
public:
	reusableMRAItimer(rtProtoBGP *b);
	~reusableMRAItimer();
  inline bool is_pending() { return status_ == TIMER_PENDING; }
  inline bool is_idle() { return 	status_ == TIMER_IDLE;}
  void reset();
  void set_offset ( float input_offset ) ;
 
//NL just for testing protected:
public:
  void expire(Event *e);
  
  /** The rtProtoBGP with which this timer is associated. */
  rtProtoBGP *bgp;

  //a map keyed by peers, where the values are vecotors of prefixes
  //for the each peer (key) the map contains vector (array) of prefix associated withe them
  //for example, when a timer expires, it will send updates about to peer 1 containing following 3 prefixes, (prefix 1, prefix 2, prefix 3)
  map < PeerEntry*, set < unsigned int > > peer_prefix ;

  //this set contains all prefexes that use this timer
  set < unsigned int > prefixes ;

public:

  //offset is the serial number of the timer
  //offset of timer describes the postion of this timer among all other offset timers
  //e.g. offset=0 is the first timer, offset=1 is the timer that starts 1 sec after the first one
  float offset;

};

#endif
